VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "CHT Code Ripper v1.2"
   ClientHeight    =   7185
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5760
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   7185
   ScaleWidth      =   5760
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdAbout 
      Caption         =   "&About"
      Height          =   375
      Left            =   3240
      TabIndex        =   17
      Top             =   6720
      Width           =   1095
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&Quit"
      Height          =   375
      Left            =   4560
      TabIndex        =   16
      Top             =   6720
      Width           =   1095
   End
   Begin VB.Frame Frame2 
      Caption         =   "Table of Codes Found"
      Height          =   4455
      Left            =   120
      TabIndex        =   3
      Top             =   2160
      Width           =   5535
      Begin VB.ListBox lstCodes 
         BackColor       =   &H00000000&
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   9
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00008000&
         Height          =   3420
         Left            =   120
         TabIndex        =   4
         Top             =   960
         Width           =   5295
      End
      Begin VB.Label lblFound 
         Alignment       =   2  'Center
         BackColor       =   &H00FFFFFF&
         BorderStyle     =   1  'Fixed Single
         Height          =   255
         Left            =   2040
         TabIndex        =   9
         Top             =   360
         Width           =   375
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Number of Codes found:"
         Height          =   210
         Index           =   3
         Left            =   120
         TabIndex        =   8
         Top             =   360
         Width           =   1770
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Hexadecimal"
         Height          =   210
         Index           =   2
         Left            =   3720
         TabIndex        =   7
         Top             =   720
         Width           =   915
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Decimal"
         Height          =   210
         Index           =   1
         Left            =   2520
         TabIndex        =   6
         Top             =   720
         Width           =   555
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Description"
         Height          =   210
         Index           =   0
         Left            =   120
         TabIndex        =   5
         Top             =   720
         Width           =   810
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Select Files"
      Height          =   1815
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5535
      Begin VB.CommandButton cmdSave 
         Caption         =   "Save to File!"
         Height          =   255
         Left            =   3000
         TabIndex        =   15
         Top             =   1440
         Width           =   1575
      End
      Begin VB.CommandButton cmdRip 
         Caption         =   "Extract Codes"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   1440
         Width           =   1575
      End
      Begin VB.CommandButton cmdBrowse 
         Caption         =   "Browse"
         Height          =   255
         Index           =   1
         Left            =   4680
         TabIndex        =   11
         Top             =   1080
         Width           =   735
      End
      Begin VB.TextBox txtOutput 
         Height          =   255
         Left            =   120
         Locked          =   -1  'True
         TabIndex        =   10
         Top             =   1080
         Width           =   4455
      End
      Begin VB.CommandButton cmdBrowse 
         Caption         =   "Browse"
         Height          =   255
         Index           =   0
         Left            =   4680
         TabIndex        =   2
         Top             =   480
         Width           =   735
      End
      Begin VB.TextBox txtFile 
         Height          =   255
         Left            =   120
         Locked          =   -1  'True
         TabIndex        =   1
         Top             =   480
         Width           =   4455
      End
      Begin VB.Label Label2 
         AutoSize        =   -1  'True
         Caption         =   "Input File:"
         Height          =   210
         Index           =   1
         Left            =   120
         TabIndex        =   13
         Top             =   240
         Width           =   675
      End
      Begin VB.Label Label2 
         AutoSize        =   -1  'True
         Caption         =   "Output File:"
         Height          =   210
         Index           =   0
         Left            =   120
         TabIndex        =   12
         Top             =   840
         Width           =   810
      End
   End
   Begin MSComDlg.CommonDialog dlgMain 
      Left            =   -360
      Top             =   3120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub RipCodes(file)
 Open file For Binary As #1
 
 ' Error trap
 If LOF(1) = 0 Then
  MsgBox "The selected file is empty", vbCritical, "Error"
  Exit Sub
 End If
 
 ' Show the Amount of codes found
 lblFound = Fix(LOF(1) / 28)
 
 ' Start Ripping the codes
 ' This operation calculates an offset
 ' NoVar = Number of Variables, 28 is the
 ' size of the block where 1 code is stored
 ' ((NoVar - 1) * 28) + 2
 Dim Code As Integer
 Dim Offset As Integer
 Dim HexOffset As String
 Dim Description As String * 18
 lstCodes.Clear
 For Code = 1 To val(lblFound)
  ' Get the OFFSET
  Get #1, (((Code - 1) * 28) + 2) + 1, Offset
  ' Transform the offset into an Unsigned
  ' Integer 0-65535
  '*** Make the offset usable by hex editors.
  UOffset = (Unsigned(Offset) + 3091)
  ' Get the Hex offset
  HexOffset = cHex(Hex(UOffset))
  ' Get the description
  Get #1, (((Code - 1) * 28) + 8) + 1, Description
  ' Add the code to the list
  '*** I changed this so that it would align right.
  lstCodes.AddItem fixLen(fixStr(Description), 18) & "    " & fixLen(UOffset, 10) & " " & fixLen(HexOffset, 10)
  Next Code
 Close #1
End Sub

Function fixLen(ByVal str As String, size As Integer) As String
 If Len(str) = size Then
  fixLen = str
  Exit Function
 End If
 ' Format the string to specified
 For i = 1 To size - Len(str)
  str = str & " "
 Next i
 fixLen = str
End Function


Function fixStr(str) As String
 For i = 1 To Len(str)
  If Asc(Mid(str, i, 1)) = 0 Then
   str = Left(str, i - 1)
   GoTo fixLen
   Exit Function
  End If
 Next i
 fixStr = str
 
fixLen:
 '*** I typed this out in a couple minutes.  I hope it works
 '*** for you.
 Dim spaces As String
 For i = 0 To 17
    If Len(str) = 0 Then
        str = str & "N/A              "
        Exit For
    End If
    If Len(str) = i Then
        For b = 1 To (17 - i)
            spaces = spaces & " "
        Next b
        str = str & spaces
        Exit For
    End If
 Next i
 fixStr = str

End Function

Function cHex(val)
 Select Case Len(val)
  Case 1, 3, 5, 7: cHex = "0" & val
  Case Else: cHex = val
 End Select
End Function

Function ConvertHex(h$) As Currency
    Dim Tmp$
    Dim lo1 As Integer, lo2 As Integer
    Dim hi1 As Long, hi2 As Long
    Const Hx = "&H"
    Const BigShift = 65536
    Const LilShift = 256, Two = 2
    Tmp = h
    'In case "&H" is present
    If UCase(Left$(h, 2)) = "&H" Then Tmp = Mid$(h, 3)
    'In case there are too few characters
    Tmp = Right$("0000000" & Tmp, 8)
    'In case it wasn't a valid number
    If IsNumeric(Hx & Tmp) Then
        lo1 = CInt(Hx & Right$(Tmp, Two))
        hi1 = CLng(Hx & Mid$(Tmp, 5, Two))
        lo2 = CInt(Hx & Mid$(Tmp, 3, Two))
        hi2 = CLng(Hx & Left$(Tmp, Two))
        ConvertHex = CCur(hi2 * LilShift + lo2) * BigShift + (hi1 * LilShift) + lo1
    End If
End Function

Public Function Unsigned(value)
    Dim A$
    A$ = Hex(value)
    If Len(A$) = 1 Then A$ = "000" & A$
    If Len(A$) = 2 Then A$ = "00" & A$
    If Len(A$) = 3 Then A$ = "0" & A$
    Unsigned = ConvertHex(A$)
End Function

Private Sub cmdAbout_Click()
MsgBox "This program was created to extract offsets from " & vbCrLf & "Zsnes CHT files." & vbCrLf & "" & vbCrLf & "Programmed by: The_Fake_God" & vbCrLf & "CHT Format: UgeTab" & vbCrLf & "v1.1 Add-ins: Cloud311" & vbCrLf & "" & vbCrLf & "Visit our site for Save State Editors, Source Code, " & vbCrLf & "Tutorials & more utilities." & vbCrLf & "" & vbCrLf & "The_Fake_God" & vbCrLf & "http://www.retrobase.com/fakegod ", 64, "About CHT Code Ripper v1.1"
End Sub

Private Sub cmdBrowse_Click(Index As Integer)
 If Index = 0 Then
  dlgMain.Filter = "Zsnes CHT files (*.cht)" + "|*.cht|"
  dlgMain.ShowOpen
  If dlgMain.FileName <> "" Then txtFile = dlgMain.FileName
 ElseIf Index = 1 Then
  dlgMain.Filter = "Plain text files (*.txt)" + "|*.txt|"
  dlgMain.ShowSave
  If dlgMain.FileName <> "" Then txtOutput = dlgMain.FileName
  If txtFile = txtOutput Then
   txtOutput = Left(txtOutput, Len(txtOutput) - 3)
   txtOutput = txtOutput & "txt"
  End If
 End If
End Sub

Private Sub cmdExit_Click()
 Unload Me
 End
End Sub

Private Sub cmdRip_Click()
'*** Added this to check if a file was opened or not.
If txtFile.Text = "" Then
    MsgBox "Please select a file."
    Exit Sub
End If
RipCodes txtFile
End Sub

Private Sub cmdSave_Click()
 '*** Notifies the user if the save didn't work.
 If txtOutput = "" Then
    MsgBox "No output file."
    Exit Sub
 End If
 
 Open txtOutput For Output As #1
  ' Print the header
  '*** I changed this so that it would look aligned.
  Print #1, "CHT Code Ripper v1.2    "
  Print #1, "by: The_Fake_God, UgeTab"
  Print #1, "http://www.retrobase.com/fakegod"
  Print #1, ""
  Print #1, "No.  Description           Decimal    Hex"
  Print #1, "-------------------------------------------"
  
  
  ' Print the data
  For i = 1 To lstCodes.ListCount
   lstCodes.Selected(i - 1) = True
   Print #1, Format(i, "000") & "  " & lstCodes.Text
  Next i
 Close #1
 lstCodes.Selected(0) = 1
End Sub

